<!DOCTYPE html>
<html lang="fr">
<head>
    <meta charset="UTF-8">
    <title>Coloriage 3D Interactif</title>
    <style>
        body { margin: 0; }
        canvas { display: block; }
    </style>
</head>
<body>
    <script type="module">
        import * as THREE from 'https://cdn.jsdelivr.net/npm/three@0.150.0/build/three.module.js';

        let scene = new THREE.Scene();
        let camera = new THREE.PerspectiveCamera(75, window.innerWidth / window.innerHeight, 0.1, 1000);
        let renderer = new THREE.WebGLRenderer();
        renderer.setSize(window.innerWidth, window.innerHeight);
        document.body.appendChild(renderer.domElement);

        // Création de la géométrie du cube avec BufferGeometry
        let geometry = new THREE.BoxBufferGeometry();
        // Initialisation des couleurs des vertex
        const numVertices = geometry.attributes.position.count;
        const colors = new Float32Array(numVertices * 3); // trois valeurs par vertex pour R, G, B
        geometry.setAttribute('color', new THREE.BufferAttribute(colors, 3));

        for (let i = 0; i < numVertices; i++) {
            colors[i * 3] = 1;     // R
            colors[i * 3 + 1] = 1; // G
            colors[i * 3 + 2] = 1; // B
        }

        let material = new THREE.MeshBasicMaterial({ vertexColors: true });
        let cu = new THREE.Mesh(geometry, material);
        scene.add(cube);

        camera.position.z = 5;

        let raycaster = new THREE.Raycaster();
        let mouse = new THREE.Vector2();

        window.addEventListener('mousemove', event => {
            mouse.x = (event.clientX / window.innerWidth) * 2 - 1;
            mouse.y = -(event.clientY / window.innerHeight) * 2 + 1;
        });

        function render() {
            requestAnimationFrame(render);
            raycaster.setFromCamera(mouse, camera);
            const intersects = raycaster.intersectObject(cube);
            if (intersects.length > 0) {
                const { face, object } = intersects[0];
                const faceVertices = [face.a, face.b, face.c];
                const colors = object.geometry.attributes.color;
                faceVertices.forEach(index => {
                    colors.setXYZ(index, Math.random(), Math.random(), Math.random());
                });
                colors.needsUpdate = true;
            }
            renderer.render(scene, camera);
        }

        render();
    </script>
</body>
</html>
